Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.pull
Class VirtualTreeWalker

    java.lang.Object
      net.sf.saxon.pull.VirtualTreeWalker

All Implemented Interfaces:
  NamespaceDeclarations, PullProvider

public class VirtualTreeWalker
extends java.lang.Object
implements PullProvider, NamespaceDeclarations

A virtual tree walker provides a sequence of pull events describing the structure and content of a tree that is conceptually being constructed by expressions in a query or stylesheet; in fact the tree is not necessarily constructed in memory, and exists only as this stream of pull events.

The tree is physically constructed if operations are requested that depend on the identity of the nodes in the tree, or that navigate within the tree. Operations such as copying or atomizing the tree can be done directly, without building it in memory. (Note however that if such operations are done more than once, the underlying instructions may be evaluated repeatedly.)

Field Summary

Fields inherited from interface net.sf.saxon.pull.PullProvider
`ATOMIC_VALUE, ATTRIBUTE, COMMENT, END_DOCUMENT, END_ELEMENT, END_OF_INPUT, NAMESPACE, PROCESSING_INSTRUCTION, START_DOCUMENT, START_ELEMENT, START_OF_INPUT, TEXT`

Constructor Summary
`VirtualTreeWalker(ParentNodeConstructor instruction, XPathContext context)` Create a VirtualTreeWalker to navigate the tree constructed by evaluating a given instruction in a given dyamic context

Method Summary
`void` | `close()` Close the event reader.
`int` | `current()` Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd().
`AtomicValue` | `getAtomicValue()` Get an atomic value.
`AttributeCollection` | `getAttributes()` Get the attributes associated with the current element.
`int` | `getFingerprint()` Get the fingerprint of the name of the element.
`int` | `getNameCode()` Get the nameCode identifying the name of the current node.
`NamePool` | `getNamePool()` Get the namepool
`int` | `getNamespaceCode(int index)` Get the n'th declaration in the list in the form of a namespace code.
`int[]` | `getNamespaceCodes(int[] buffer)` Get all the namespace codes, as an array.
`NamespaceDeclarations` | `getNamespaceDeclarations()` Get the namespace declarations associated with the current element.
`int` | `getNumberOfNamespaces()` Get the number of declarations (and undeclarations) in this list.
`PipelineConfiguration` | `getPipelineConfiguration()` Get configuration information.
`java.lang.String` | `getPrefix(int index)` Get the prefix of the n'th declaration (or undeclaration) in the list, counting from zero.
`javax.xml.transform.SourceLocator` | `getSourceLocator()` Get the location of the current event.
`java.lang.CharSequence` | `getStringValue()` Get the string value of the current element, text node, processing-instruction, or top-level attribute or namespace node, or atomic value.
`int` | `getTypeAnnotation()` Get the type annotation of the current attribute or element node, or atomic value.
`java.lang.String` | `getURI(int index)` Get the namespace URI of the n'th declaration (or undeclaration) in the list, counting from zero.
`int` | `next()` Get the next event
`void` | `setNameCode(int nameCode)` Set the initial nameCode (the nameCode of the node at the root of the tree being walked)
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set configuration information.
`int` | `skipToMatchingEnd()` Skip the current subtree.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### VirtualTreeWalker

    public VirtualTreeWalker(ParentNodeConstructor instruction,
                             XPathContext context)

  Create a VirtualTreeWalker to navigate the tree constructed by evaluating a given instruction in a given dyamic context

Parameters:
  `instruction` - the instruction (this will always be an instruction that creates element or document nodes)
  `context` - the dynamic evaluation context

Method Detail

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Set configuration information. This must only be called before any events have been read.

  Specified by:
    `setPipelineConfiguration` in interface `PullProvider`

### getPipelineConfiguration

    public PipelineConfiguration getPipelineConfiguration()

  Get configuration information.

  Specified by:
    `getPipelineConfiguration` in interface `PullProvider`

### getNamePool

    public NamePool getNamePool()

  Get the namepool

### next

    public int next()
             throws XPathException

  Get the next event

  Specified by:
    `next` in interface `PullProvider`
  Returns:
    an integer code indicating the type of event. The code `PullProvider.END_OF_INPUT` is returned at the end of the sequence.
  Throws:
    `XPathException`

### current

    public int current()

  Get the event most recently returned by next(), or by other calls that change the position, for example getStringValue() and skipToMatchingEnd(). This method does not change the position of the PullProvider.

  Specified by:
    `current` in interface `PullProvider`
  Returns:
    the current event

### getAttributes

    public AttributeCollection getAttributes()
                                      throws XPathException

  Get the attributes associated with the current element. This method must be called only after a START_ELEMENT event has been notified. The contents of the returned AttributeCollection are guaranteed to remain unchanged until the next START_ELEMENT event, but may be modified thereafter. The object should not be modified by the client.

  Attributes may be read before or after reading the namespaces of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

  Specified by:
    `getAttributes` in interface `PullProvider`
  Returns:
    an AttributeCollection representing the attributes of the element that has just been notified.
  Throws:
    `XPathException`

### getNamespaceDeclarations

    public NamespaceDeclarations getNamespaceDeclarations()
                                                   throws XPathException

  Get the namespace declarations associated with the current element. This method must be called only after a START_ELEMENT event has been notified. In the case of a top-level START_ELEMENT event (that is, an element that either has no parent node, or whose parent is not included in the sequence being read), the NamespaceDeclarations object returned will contain a namespace declaration for each namespace that is in-scope for this element node. In the case of a non-top-level element, the NamespaceDeclarations will contain a set of namespace declarations and undeclarations, representing the differences between this element and its parent.

  It is permissible for this method to return namespace declarations that are redundant.

  The NamespaceDeclarations object is guaranteed to remain unchanged until the next START_ELEMENT event, but may then be overwritten. The object should not be modified by the client.

  Namespaces may be read before or after reading the attributes of an element, but must not be read after the first child node has been read, or after calling one of the methods skipToEnd(), getStringValue(), or getTypedValue().

  *

  Specified by:
    `getNamespaceDeclarations` in interface `PullProvider`
  Throws:
    `XPathException`

### skipToMatchingEnd

    public int skipToMatchingEnd()
                          throws XPathException

  Skip the current subtree. This method may be called only immediately after a START_DOCUMENT or START_ELEMENT event. This call returns the matching END_DOCUMENT or END_ELEMENT event; the next call on next() will return the event following the END_DOCUMENT or END_ELEMENT.

  Specified by:
    `skipToMatchingEnd` in interface `PullProvider`
  Throws:
    `java.lang.IllegalStateException` - if the method is called at any time other than immediately after a START_DOCUMENT or START_ELEMENT event.
    `XPathException`

### close

    public void close()

  Close the event reader. This indicates that no further events are required. It is not necessary to close an event reader after `PullProvider.END_OF_INPUT` has been reported, but it is recommended to close it if reading terminates prematurely. Once an event reader has been closed, the effect of further calls on next() is undefined.

  Specified by:
    `close` in interface `PullProvider`

### setNameCode

    public void setNameCode(int nameCode)

  Set the initial nameCode (the nameCode of the node at the root of the tree being walked)

### getNameCode

    public int getNameCode()

  Get the nameCode identifying the name of the current node. This method can be used after the `PullProvider.START_ELEMENT`, `PullProvider.END_ELEMENT`, `PullProvider.PROCESSING_INSTRUCTION`, `PullProvider.ATTRIBUTE`, or `PullProvider.NAMESPACE` events. With some PullProvider implementations, but not this one, it can also be used after `PullProvider.END_ELEMENT`. If called at other times, the result is undefined and may result in an IllegalStateException. If called when the current node is an unnamed namespace node (a node representing the default namespace) the returned value is -1.

  Specified by:
    `getNameCode` in interface `PullProvider`
  Returns:
    the nameCode. The nameCode can be used to obtain the prefix, local name, and namespace URI from the name pool.

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the name of the element. This is similar to the nameCode, except that it does not contain any information about the prefix: so two elements with the same fingerprint have the same name, excluding prefix. This method can be used after the `PullProvider.START_ELEMENT`, `PullProvider.END_ELEMENT`, `PullProvider.PROCESSING_INSTRUCTION`, `PullProvider.ATTRIBUTE`, or `PullProvider.NAMESPACE` events. If called at other times, the result is undefined and may result in an IllegalStateException. If called when the current node is an unnamed namespace node (a node representing the default namespace) the returned value is -1.

  Specified by:
    `getFingerprint` in interface `PullProvider`
  Returns:
    the fingerprint. The fingerprint can be used to obtain the local name and namespace URI from the name pool.

### getStringValue

    public java.lang.CharSequence getStringValue()
                                          throws XPathException

  Get the string value of the current element, text node, processing-instruction, or top-level attribute or namespace node, or atomic value.

  In other situations the result is undefined and may result in an IllegalStateException.

  If the most recent event was a `PullProvider.START_ELEMENT`, this method causes the content of the element to be read. The current event on completion of this method will be the corresponding `PullProvider.END_ELEMENT`. The next call of next() will return the event following the END_ELEMENT event.

  Specified by:
    `getStringValue` in interface `PullProvider`
  Returns:
    the String Value of the node in question, defined according to the rules in the XPath data model.
  Throws:
    `XPathException`

### getAtomicValue

    public AtomicValue getAtomicValue()

  Get an atomic value. This call may be used only when the last event reported was ATOMIC_VALUE. This indicates that the PullProvider is reading a sequence that contains a free-standing atomic value; it is never used when reading the content of a node.

  Specified by:
    `getAtomicValue` in interface `PullProvider`

### getTypeAnnotation

    public int getTypeAnnotation()

  Get the type annotation of the current attribute or element node, or atomic value. The result of this method is undefined unless the most recent event was START_ELEMENT, ATTRIBUTE, or ATOMIC_VALUE.

  Specified by:
    `getTypeAnnotation` in interface `PullProvider`
  Returns:
    the type annotation. This code is the fingerprint of a type name, which may be resolved to a `SchemaType` by access to the Configuration.

### getSourceLocator

    public javax.xml.transform.SourceLocator getSourceLocator()

  Get the location of the current event. For an event stream representing a real document, the location information should identify the location in the lexical XML source. For a constructed document, it should identify the location in the query or stylesheet that caused the node to be created. A value of null can be returned if no location information is available.

  Specified by:
    `getSourceLocator` in interface `PullProvider`

### getNumberOfNamespaces

    public int getNumberOfNamespaces()

  Get the number of declarations (and undeclarations) in this list.

  Specified by:
    `getNumberOfNamespaces` in interface `NamespaceDeclarations`

### getPrefix

    public java.lang.String getPrefix(int index)

  Get the prefix of the n'th declaration (or undeclaration) in the list, counting from zero.

  Specified by:
    `getPrefix` in interface `NamespaceDeclarations`
  Parameters:
    `index` - the index identifying which declaration is required.
  Returns:
    the namespace prefix. For a declaration or undeclaration of the default namespace, this is the zero-length string.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range.

### getURI

    public java.lang.String getURI(int index)

  Get the namespace URI of the n'th declaration (or undeclaration) in the list, counting from zero.

  Specified by:
    `getURI` in interface `NamespaceDeclarations`
  Parameters:
    `index` - the index identifying which declaration is required.
  Returns:
    the namespace URI. For a namespace undeclaration, this is the zero-length string.
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range.

### getNamespaceCode

    public int getNamespaceCode(int index)

  Get the n'th declaration in the list in the form of a namespace code. Namespace codes can be translated into a prefix and URI by means of methods in the NamePool

  Specified by:
    `getNamespaceCode` in interface `NamespaceDeclarations`
  Parameters:
    `index` - the index identifying which declaration is required.
  Returns:
    the namespace code. This is an integer whose upper half indicates the prefix (0 represents the default namespace), and whose lower half indicates the URI (0 represents an undeclaration).
  Throws:
    `java.lang.IndexOutOfBoundsException` - if the index is out of range.
  See Also:
    `NamePool.getPrefixFromNamespaceCode(int)`, `NamePool.getURIFromNamespaceCode(int)`

### getNamespaceCodes

    public int[] getNamespaceCodes(int[] buffer)

  Get all the namespace codes, as an array.

  Specified by:
    `getNamespaceCodes` in interface `NamespaceDeclarations`
  Parameters:
    `buffer` - a sacrificial array that the method is free to use to contain the result. May be null.
  Returns:
    an integer array containing namespace codes. The array may be filled completely with namespace codes, or it may be incompletely filled, in which case a -1 integer acts as a terminator.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD